Module modFile
    Private cInvalidChars() As Char = {"\", "/", ":", "*", "?", """", ">", "<", "|"}

    Public Sub GetAllFiles(ByVal folder As String, _
            ByVal searchPattern As String, ByRef files As ArrayList)
        Try
            'folderɂt@C擾
            'If InStr(folder, "System Volume Information") > 0 Then Exit Sub
            Dim fs As String() = _
                System.IO.Directory.GetFiles(folder, searchPattern)
            'ArrayListɒǉ
            Dim f As String
            For Each f In fs
                If files.IndexOf(f) < 0 Then
                    files.Add(f)
                End If
            Next f

            'folder̃TutH_擾
            Dim ds As String() = System.IO.Directory.GetDirectories(folder)
            'TutH_ɂt@Cׂ
            Dim d As String
            For Each d In ds
                GetAllFiles(d, searchPattern, files)
            Next d
        Catch ex As Exception

        End Try
    End Sub

    Public Function GetPlayListFile(ByVal sFile As String) As String
        Dim sPlayListFile As String
        sPlayListFile = GetOtherFile(sFile, True)
        If System.IO.File.Exists(sPlayListFile) Then
            Return sPlayListFile
        End If
        Return ""
    End Function

    Public Function GetStreamFiles(ByVal sFile As String, Optional ByVal sFileName As String = "") As String()
        'Dim sStreamFiles(0) As String
        Dim sStreamFile As String
        'sStreamFile = GetOtherFile(sFile, False)
        Dim sFolder As String
        Dim sName As String
        'Dim sExtension As String
        If Not System.IO.File.Exists(sFile) Then Exit Function
        sFolder = System.IO.Path.GetDirectoryName(sFile)
        sFolder = System.IO.Path.GetDirectoryName(sFolder)
        sFolder = sFolder & "\STREAM\"

        'If System.IO.File.Exists(sStreamFile) Then
        '    sStreamFiles(0) = sStreamFile
        '    Return sStreamFiles
        'Else
        'folderɂt@C擾
        ''Dim sFolder As String = System.IO.Path.GetDirectoryName(sStreamFile)
        ''Dim sName As String = System.IO.Path.GetFileName(sFile)
        'sName = Left(sName, 5)
        'Dim sExtension As String = System.IO.Path.GetExtension(sFile)
        'sName = Left(sName, Len(sName) - Len(sExtension))
        'sName = sName & "*.*"
        sName = sFileName & "*.*"

        If System.IO.Directory.Exists(sFolder) Then
            Dim fs As String() = System.IO.Directory.GetFiles(sFolder, sName)
            Return fs
        End If

        'End If
    End Function

    Public Function GetPlayListNo(ByVal sFile As String) As String
        Dim sName As String
        Dim sFolder As String
        Try
            If Not System.IO.File.Exists(sFile) Then Return "0000"
            sFolder = System.IO.Path.GetDirectoryName(sFile)
            sFolder = System.IO.Path.GetDirectoryName(sFolder)
            sName = System.IO.Path.GetFileName(sFile)

            Dim sInfoBdavName As String = sFolder & "\info.bdav"
            If Not System.IO.File.Exists(sInfoBdavName) Then Return "0000"
            Dim nInfoBdavNo As Integer = GetInfoBdavNo(sFolder & "\info.bdav")
            Dim uIFBDAV As info_bdav = uInfoBdav(nInfoBdavNo)
            If uIFBDAV.Path = "" Then Return "0000"

            Dim I As Integer
            Dim n As Integer = uIFBDAV.PlayList.Length - 1
            Dim sNo As String
            For I = 1 To n
                If StrComp(uIFBDAV.PlayList(I), sName, CompareMethod.Text) = 0 Then
                    sNo = Format(nInfoBdavNo, "00") & Format(I, "00")
                    Return sNo
                End If
            Next
            Return "0000"
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try
    End Function

    Public Function SaveCsvFile(ByVal DataGrid1 As DataGrid, ByVal sFile As String) As Boolean
        Try
            SaveCsvFile = False

            'CSVŕۑDataTable
            Dim dt As DataTable = CType(DataGrid1.DataSource, DataTable)
            'ۑCSVt@C̃pX
            Dim csvPath As String = sFile
            'CSVt@CɏނƂɎgEncoding
            Dim enc As System.Text.Encoding = _
                System.Text.Encoding.GetEncoding("Shift_JIS")

            'J
            Dim sr As New System.IO.StreamWriter(csvPath, False, enc)

            Dim colCount As Integer = dt.Columns.Count
            Dim lastColIndex As Integer = colCount - 2

            'wb_
            Dim i As Integer
            For i = 0 To lastColIndex
                'wb_̎擾
                Dim field As String = dt.Columns(i).Caption
                '"ň͂ޕKv邩ׂ
                If field.IndexOf(ControlChars.Quote) > -1 OrElse _
                    field.IndexOf(","c) > -1 OrElse _
                    field.IndexOf(ControlChars.Cr) > -1 OrElse _
                    field.IndexOf(ControlChars.Lf) > -1 OrElse _
                    field.StartsWith(" ") OrElse _
                    field.StartsWith(ControlChars.Tab) OrElse _
                    field.EndsWith(" ") OrElse _
                    field.EndsWith(ControlChars.Tab) Then
                    If field.IndexOf(ControlChars.Quote) > -1 Then
                        '"""Ƃ
                        field = field.Replace("""", """""")
                    End If
                    field = """" + field + """"
                End If
                'tB[h
                sr.Write(field)
                'J}
                If lastColIndex > i Then
                    sr.Write(","c)
                End If
            Next i
            's
            sr.Write(ControlChars.Cr + ControlChars.Lf)

            'R[h
            Dim row As DataRow
            Dim r As Integer
            'For Each row In dt.Rows
            For r = 0 To DataGrid1.DataSource.DefaultView.Count - 1
                row = DataGrid1.DataSource.DefaultView.Item(r).Row
                For i = 0 To lastColIndex
                    'tB[h̎擾
                    Dim field As String = row(i).ToString()
                    '"ň͂ޕKv邩ׂ
                    If field.IndexOf(ControlChars.Quote) > -1 OrElse _
                        field.IndexOf(","c) > -1 OrElse _
                        field.IndexOf(ControlChars.Cr) > -1 OrElse _
                        field.IndexOf(ControlChars.Lf) > -1 OrElse _
                        field.StartsWith(" ") OrElse _
                        field.StartsWith(ControlChars.Tab) OrElse _
                        field.EndsWith(" ") OrElse _
                        field.EndsWith(ControlChars.Tab) Then
                        If field.IndexOf(ControlChars.Quote) > -1 Then
                            '"""Ƃ
                            field = field.Replace("""", """""")
                        End If
                        field = """" + field + """"
                    End If
                    'tB[h
                    sr.Write(field)
                    'J}
                    If lastColIndex > i Then
                        sr.Write(","c)
                    End If
                Next i
                's
                sr.Write(ControlChars.Cr + ControlChars.Lf)
            Next r

            '
            sr.Close()
            Return True
        Catch ex As Exception
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try
    End Function

    Public Function LoadCsvFile(ByVal sFile As String) As System.Collections.ArrayList
        Dim br As System.IO.FileStream
        Try
            br = New System.IO.FileStream(sFile, IO.FileMode.Open, IO.FileAccess.Read, IO.FileShare.ReadWrite)
            If br.Length >= 1024 * 1024 Then
                br.Close()
                Return Nothing
            End If

            Dim ByteArray(br.Length - 1) As Byte
            Dim nBytesRead As Integer = br.Read(ByteArray, 0, br.Length)
            If nBytesRead <= 0 Then
                br.Close()
                Return Nothing
            End If

            Dim csvText As String = System.Text.Encoding.GetEncoding(R[h.VtgJIS).GetString(ByteArray)
            br.Close()

            Return CsvToArrayList1(csvText)
        Catch ex As Exception
            If Not br Is Nothing Then br.Close()
            MsgBox(ex.ToString, MsgBoxStyle.Critical)    ' Show friendly error message
        End Try
    End Function

    ''' <summary>
    ''' CSVArrayListɕϊ
    ''' </summary>
    ''' <param name="csvText">CSV̓eString</param>
    ''' <returns>ϊʂArrayList</returns>
    Public Function CsvToArrayList1(ByVal csvText As String) _
        As System.Collections.ArrayList
        Dim csvRecords As New System.Collections.ArrayList

        'Ỏs폜Ă
        csvText = csvText.Trim( _
            New Char() {ControlChars.Cr, ControlChars.Lf})

        'so߂̐K\
        Dim regLine As New System.Text.RegularExpressions.Regex( _
            "^.*(?:\n|$)", _
            System.Text.RegularExpressions.RegexOptions.Multiline)

        '1sCSVetB[h擾邽߂̐K\
        Dim regCsv As New System.Text.RegularExpressions.Regex( _
            "\s*(""(?:[^""]|"""")*""|[^,]*)\s*,", _
            System.Text.RegularExpressions.RegexOptions.None)

        Dim mLine As System.Text.RegularExpressions.Match = _
            regLine.Match(csvText)
        While mLine.Success
            'so
            Dim line As String = mLine.Value
            'sL"ň͂܂Ă邩ׂ
            While CountString(line, """") Mod 2 = 1
                mLine = mLine.NextMatch()
                If Not mLine.Success Then
                    Return Nothing
                    Throw New ApplicationException("sCSV")
                End If
                line += mLine.Value
            End While
            's̍Ō̉sL폜
            line = line.TrimEnd( _
                New Char() {ControlChars.Cr, ControlChars.Lf})
            'ŌɁu,v
            line += ","

            '1̍stB[ho
            Dim csvFields As New System.Collections.ArrayList
            Dim m As System.Text.RegularExpressions.Match = _
                regCsv.Match(line)
            While m.Success
                Dim field As String = m.Groups(1).Value
                'Ő󔒂폜
                field = field.Trim()
                '"ň͂܂Ă鎞
                If field.StartsWith("""") And field.EndsWith("""") Then
                    'O"
                    field = field.Substring(1, field.Length - 2)
                    'u""vu"vɂ
                    field = field.Replace("""""", """")
                End If
                csvFields.Add(field)
                m = m.NextMatch()
            End While

            csvFields.TrimToSize()
            csvRecords.Add(csvFields)

            mLine = mLine.NextMatch()
        End While

        csvRecords.TrimToSize()
        Return csvRecords
    End Function

    ''' <summary>
    ''' w肳ꂽɂ镶񂪊邩
    ''' </summary>
    ''' <param name="strInput">strFind邩镶</param>
    ''' <param name="strFind">镶</param>
    ''' <returns>strInputstrFind</returns>
    Public Function CountString( _
        ByVal strInput As String, _
        ByVal strFind As String) As Integer
        Dim foundCount As Integer = 0
        Dim sPos As Integer = strInput.IndexOf(strFind)
        While sPos > -1
            foundCount += 1
            sPos = strInput.IndexOf(strFind, sPos + 1)
        End While

        Return foundCount
    End Function

    Public Function CheckFile(ByVal sFile As String) As Boolean
        Try
            If Trim(sFile) = "" Then Return False
            If Not System.IO.Path.IsPathRooted(sFile) Then Return False
            If Not System.IO.File.Exists(sFile) Then Return False

            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    Public Function CheckInvalidChars(ByVal sFile As String) As String
        'Try
        If sFile.IndexOfAny(cInvalidChars) < 0 Then Return sFile
        Dim c As Char
        For Each c In cInvalidChars
            If sFile.IndexOf(c) >= 0 Then
                If c = "\" Then
                    sFile = Replace(sFile, "\", "")
                Else
                    sFile = Replace(sFile, c, StrConv(c, VbStrConv.Wide))
                    'Debug.WriteLine(StrConv(c.ToString, VbStrConv.Wide))
                End If
            End If
        Next
        Return sFile
        'Catch ex As Exception
        '    Return sFile
        'End Try
    End Function
End Module
